All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Components |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sas.graphics.components.ganttchart
Class GanttChartTableDataModel

    com.sas.graphics.components.ganttchart.GanttChartTableDataModel

    public class GanttChartTableDataModel

A GanttChartTableDataModel encapsulates relational data from a javax.swing.table.TableModel and maps the TableModel's data columns onto a GanttChart component. To do the mapping, it assigns variable roles to the data columns that will be used in the graph, and the assigned roles determine the data display.

Generally, the GanttChartTableDataModel is used to access a project's list of tasks and its significant schedule dates, such as the project's predicted start and finish dates, actual start and finish dates, and baseline dates.

The GanttChartTableDataModel can also define annotations to display on the chart. The annotations can be marker symbols or text labels and can include the color values to use for the annotation display.

Annotations that are defined in a GanttChartTableDataModel are limited to one annotation per task. To assign multiple annotations per task, or to separate annotation data from schedule data, create a separate data source for the annotations and define them with a GanttChartAnnotationTableDataModel. NOTE: These annotations are not included in the public api and are experimental and subject to change in future releases.

Topics:
  Basic Charts
  Schedule Dates
  Target Dates
  Break Times
  Duration Interval
  Hierarchical Tasks
  Bar Colors
  Bar Visibility
  Connecting Lines
  Annotations
  Data Tips
  Behavior
  Samples

Since:
  SAS 9.1
See Also:
  `GanttChartDataModel`, `GanttChart`

Constructor Summary
`GanttChartTableDataModel()` Default Constructor
`GanttChartTableDataModel(javax.swing.table.TableModel newModel)` Constructor with assigned model

Method Summary
`void` | `apply(GanttChartTableDataModel theOtherModel)` Utility method to convey properties contained in "theOtherModel" to this object.
`boolean` | `equals(java.lang.Object obj)` Determines whether another object is equal to this `GanttChartTableDataModel`.
`Variable` | `getActualFinishVariable()` Returns the data column that was most recently set in the ActualFinish role by the setActualFinishVariable() method.
`Variable` | `getActualStartVariable()` Returns the data column that was most recently set in the ActualStart role by the setActualStartVariable() method.
`Variable` | `getAnnotationLabelColorVariable()` Returns the data column that was most recently set in the AnnotationLabelColor role by the setAnnotationLabelColorVariable() method.
`Variable` | `getAnnotationLabelJustificationVariable()` Returns the data column that was most recently set in the AnnotationLabelJustification role by the setannotationLabelJustificationVariable() method.
`Variable` | `getAnnotationLabelVariable()` Returns the data column that was most recently set in the AnnotationLabel role by the setAnnotationLabelVariable() method.
`Variable` | `getAnnotationLocationVariable()` Returns the data column that was most recently set in the AnnotationLocation role by the setAnnotationLocationVariable() method.
`Variable` | `getAnnotationPositionVariable()` Returns the data column that was most recently set in the AnnotationPosition role by the setAnnotationPositionVariable() method.
`Variable` | `getAnnotationSymbolColorVariable()` Returns the data column that was most recently set in the AnnotationSymbolColor role by the setAnnotationSymbolColorVariable() method.
`Variable` | `getAnnotationSymbolVariable()` Returns the data column that was most recently set in the AnnotationSymbol role by the setAnnotationSymbolVariable() method.
`GanttChartAnnotationTableDataModel` | `getAnnotationTableDataModel()`
`Variable` | `getAnnotationTaskVariable()` Returns the data column that was most recently set in the AnnotationTask role by the setAnnotationTaskVariable() method.
`Variable[]` | `getAuxiliaryVariable()` Returns the array of data columns that was most recently set by the setAuxiliaryVariable() method.
`Variable` | `getBaselineFinishVariable()` Returns the data column that was most recently set in the BaselineFinish role by the setBaselineFinishVariable() method.
`Variable` | `getBaselineStartVariable()` Returns the data column that was most recently set in the BaselineStart role by the setBaselineStartVariable() method.
`GanttChartBreakTimeTableDataModel` | `getBreakTimeTableDataModel()`
`Variable` | `getCalendarVariable()` Returns the data column that was most recently set in the calendar role by the setCalendarVariable() method.
`Variable` | `getColorVariable()` Returns the data column that was most recently set in the Color role by the setColorVariable() method.
`Variable` | `getCustomSchedule1FinshVariable()` Returns the data column that was most recently set in the Custom Schedule 1 Finish role.
`Variable` | `getCustomSchedule1StartVariable()` Returns the data column that was most recently set in the CustomSchedule1Start role.
`Variable` | `getCustomSchedule2FinshVariable()` Returns the data column that was most recently set in the Custom Schedule 2 Finish role.
`Variable` | `getCustomSchedule2StartVariable()` Returns the data column that was most recently set in the Custom Schedule 2 Start role.
`Variable[]` | `getDataTipVariable()` Returns the array of data columns that was most recently set by the setDataTipVariable() method.
`Variable` | `getDescriptionVariable()` Returns the data column that was most recently set in the Description role by the setDescriptionVariable() method.
`Variable` | `getDrawBarVariable()` Returns the data column that was most recently set in the DrawBar role by the setDrawBarVariable() method.
`Variable` | `getDurationVariable()` Returns the data column that was most recently set in the Duration role by the setDurationVariable() method.
`Variable` | `getEarlyFinishVariable()` Returns the data column that was most recently set in the EarlyFinish role by the setEarlyFinishVariable() method.
`Variable` | `getEarlyStartVariable()` Returns the data column that was most recently set in the EarlyStart role by the setEarlyStartVariable() method.
`Variable` | `getLateFinishVariable()` Returns the data column that was most recently set in the LateFinish role by the setLateFinishVariable() method.
`Variable` | `getLateStartVariable()` Returns the data column that was most recently set in the LateStart role by the setLateStartVariable() method.
`javax.swing.table.TableModel` | `getModel()` Returns the Swing TableModel containing chart data.
`Variable` | `getParentVariable()` Returns the data column that was most recently set in the Parent role by the setParentVariable() method.
`Variable` | `getReplaceWithChildrenVariable()` Returns the data column that was most recently set in the ReplaceWithChildren role by the setReplaceWithChildrenVariable() method.
`Variable` | `getResourceFinishVariable()` Returns the data column that was most recently set in the ResourceFinish role by the setResourceFinishVariable() method.
`Variable` | `getResourceStartVariable()` Returns the data column that was most recently set in the ResourceStart role by the setResourceStartVariable() method.
`java.lang.String` | `getRoot()` Returns the text that is used for the root of a treetable.
`javax.swing.ListSelectionModel` | `getSelectionModel()` Returns the ListSelectionModel that indicates which data values are selected.
`Variable` | `getStyleByVariable()` Returns the data column that was most recently set in the StyleBy role by the setStyleByVariable() method.
`Variable` | `getSuccessorVariable()` Returns the data column that was most recently set in the Successor role by the setSuccessorVariable() method.
`Variable` | `getTargetVariable()` Returns the data column that was most recently set in the Target role by the setTargetVariable() method.
`Variable` | `getTaskVariable()` Returns the data column that was most recently set in the Task role by the setTaskVariable() method.
`int` | `hashCode()` Computes the hash code for this `GanttChartTableDataModel`.
`boolean` | `isTime()` Deprecated. use
`void` | `setActualFinishVariable(Variable newVariable)` Specifies a variable containing the calendar date work actually ended on an activity.
`void` | `setActualStartVariable(Variable newVariable)` Specifies a variable containing the calendar date work actually began on an activity.
`void` | `setAnnotationLabelColorVariable(Variable newVariable)` Specifies a variable containing color values for the text used for displaying annotations.
`void` | `setAnnotationLabelJustificationVariable(Variable newVariable)` Specifies a String variable whose values identify justification to use for displaying annotations.
`void` | `setAnnotationLabelVariable(Variable newVariable)` Specifies a String Variable whose values specify the text to use for displaying annotations.
`void` | `setAnnotationLocationVariable(Variable newVariable)` Specifies a String variable whose values identify a date-axis location to use for displaying annotations.
`void` | `setAnnotationPositionVariable(Variable newVariable)` Specifies a variable whose values identify a specific date-axis location to use for displaying annotations.
`void` | `setAnnotationSymbolColorVariable(Variable newVariable)` Specifies a variable containing color values for the marker symbols used for displaying annotations.
`void` | `setAnnotationSymbolVariable(Variable newVariable)` Specifies a Variable whose values specify the symbol to use for displaying annotations.
`void` | `setAnnotationTableDataModel(GanttChartAnnotationTableDataModel annotationTableDataModel)` Sets the annotation data model that will be used to set annotations on the chart.
`void` | `setAnnotationTaskVariable(Variable newVariable)` Specifies a variable whose values identify the task bars to use for displaying annotations on the chart.
`void` | `setAuxiliaryVariable(Variable[] newVariables)` Specifies an array of Variables that are included among the variables that are passed in the events on the Gantt bars.
`void` | `setBaselineFinishVariable(Variable newVariable)` Specifies a variable containing calendar date of when work is scheduled to end on an activity.
`void` | `setBaselineStartVariable(Variable newVariable)` Specifies variable containing the calendar date when work was scheduled to begin on an activity.
`void` | `setBreakTimeTableDataModel(GanttChartBreakTimeTableDataModel breakTimeTableDataModel)` Sets the break time data model that will be used to
`void` | `setCalendarVariable(Variable newVariable)` Specifies a variable containing the calendar variable value in which to draw breaks in schedule.
`void` | `setColorVariable(Variable newVariable)` Specifies a variable containing the color values for the bars.
`void` | `setCustomSchedule1FinishVariable(Variable newVariable)` Specifies the variable containing Custom Schedule 1 constraint finish dates.
`void` | `setCustomSchedule1StartVariable(Variable newVariable)` Specifies the variable containing Custom Schedule 1 constraint finish dates.
`void` | `setCustomSchedule2FinishVariable(Variable newVariable)` Specifies the variable containing Custom Schedule 2 constraint finish dates.
`void` | `setCustomSchedule2StartVariable(Variable newVariable)` Specifies the variable containing Custom Schedule 2 constraint finish dates.
`void` | `setDataTipVariable(Variable[] newVariables)` Specifies an array of Variables to be displayed in the data tip.
`void` | `setDescriptionVariable(Variable newVariable)` Specifies a variable containing text to be displayed in the TreeTable instead of the actual Task variable values.
`void` | `setDrawBarVariable(Variable newVariable)` Specifies a numeric Variable for determining whether chart bars are drawn.
`void` | `setDurationVariable(Variable newVariable)` Duration of an activity.
`void` | `setEarlyFinishVariable(Variable newVariable)` Specifies a variable containing the earliest possible point in time on which the uncompleted portions of an activity can finish, based on the network logic and any schedule constraints.
`void` | `setEarlyStartVariable(Variable newVariable)` Specifies a variable containing the earliest possible point in time on which the uncompleted portions of an activity can start, based on the network logic and any schedule constraints.
`void` | `setLateFinishVariable(Variable newVariable)` Specifies the latest possible point in time that an activity can be completed without delaying a specific milestone (usually the project finish date).
`void` | `setLateStartVariable(Variable newVariable)` Specifies variable contining the latest possible point in time that an activity can begin without delaying a specified milestone (ususally the project finish date).
`void` | `setModel(javax.swing.table.TableModel newModel)` Sets Swing TableModel containing chart data.
`void` | `setParentVariable(Variable newVariable)` Specifies a variable containing the parent value for each task and is used in displaying hierarchial tasks on the task axis.
`void` | `setReplaceWithChildrenVariable(Variable newVariable)` Specifies a variable whose values let the chart know if it is to draw the children of this task on this row instead of drawing the task bar.
`void` | `setResourceFinishVariable(Variable newVariable)` Specifies the variable containing resource constraint finish dates.
`void` | `setResourceStartVariable(Variable newVariable)` Specifies variable containing resource constraint start date.
`void` | `setRoot(java.lang.String newRootText)` Identifies the data value for the task in the tree root position in a hierarchical treetable.
`void` | `setSelectionModel(javax.swing.ListSelectionModel newModel)` Sets the ListSelectionModel which indicates which data values are selected.
`void` | `setStyleByVariable(Variable newVariable)` Specifies Style By Variable for coloring chart bars.
`void` | `setSuccessorVariable(Variable newVariable)` Specifies a successor Variable for an activity.
`void` | `setTargetVariable(Variable newVariable)` Specifies a variable containing the target dates Note: All chart's date Variables must be in the same date format and have a valid date format specifed on the Variable.
`void` | `setTaskVariable(Variable newVariable)` Specifies Task Variable for chart bars.

Methods inherited from class com.sas.graphics.components.DataModel
`apply, getLocale, getRulesContext, getSortStrategy, setLocale, setRulesContext, setSortStrategy`

Methods inherited from class com.sas.graphics.components.ModelBase
`addPropertyChangeListener, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, removePropertyChangeListener, setContainedModel`

Constructor Detail

### GanttChartTableDataModel

    public GanttChartTableDataModel()

  Default Constructor

### GanttChartTableDataModel

    public GanttChartTableDataModel(javax.swing.table.TableModel newModel)

  Constructor with assigned model

Method Detail

### apply

    public void apply(GanttChartTableDataModel theOtherModel)

  Utility method to convey properties contained in "theOtherModel" to this object.
  Note: Contained "models" (i.e. properties that are subclasses of ModelBase) will in turn be called on to convey their properties to the like contained models in the other object. In that respect this can be considered a "tree" type copy.
  Also Note: This is a deep copy. Thus after the copy, mutable properties will not be shared by the two instances.

  Parameters:
    `theOtherModel` - properties applied to this instance

### setRoot

    public void setRoot(java.lang.String newRootText)

  Identifies the data value for the task in the tree root position in a hierarchical treetable. By default, the data value for the tree root task is "Project Summary". If the actual data value for the tree root task is different, this method must be called to pass that value to the axis model. Otherwise, the chart does not locate the tree root value needed to construct the hierarchical display, and it therefore displays all task-axis variables at the same level, with no hierarchy. For more information, see the GanttChartTableDataModel discussion of Hierarchical Tasks.

  Parameters:
    `newRootText` - string to be used for root node
  See Also:
    `getRoot()`

### getRoot

    public java.lang.String getRoot()

  Returns the text that is used for the root of a treetable. The default is "Project Summary".

  Returns:
    Sting containing the root parent.
  See Also:
    `setRoot(java.lang.String)`

### setAnnotationTableDataModel

    public void setAnnotationTableDataModel(GanttChartAnnotationTableDataModel annotationTableDataModel)

  Sets the annotation data model that will be used to set annotations on the chart.

  Parameters:
    `annotationTableDataModel` - The annotationTableDataModel to set.

### getAnnotationTableDataModel

    public GanttChartAnnotationTableDataModel getAnnotationTableDataModel()

  Returns:
    Returns the annotationTableDataModel.

### setBreakTimeTableDataModel

    public void setBreakTimeTableDataModel(GanttChartBreakTimeTableDataModel breakTimeTableDataModel)

  Sets the break time data model that will be used to

  Parameters:
    `breakTimeTableDataModel` - The break time TableDataModel to set.

### getBreakTimeTableDataModel

    public GanttChartBreakTimeTableDataModel getBreakTimeTableDataModel()

  Returns:
    Returns the break time TableDataModel.

### equals

    public boolean equals(java.lang.Object obj)

  Determines whether another object is equal to this `GanttChartTableDataModel`.

  The result is `true` if and only if the argument is not `null` and is a `GanttChartTableDataModel` object that has the same property values as this object.

  Overrides:
    `equals` in class `DataModel`
  Parameters:
    `obj` - the object to test for equality with this `GanttChartTableDataModel`
  Returns:
    `true` if the objects are the same; `false` otherwise.

### hashCode

    public int hashCode()

  Computes the hash code for this `GanttChartTableDataModel`.

  Overrides:
    `hashCode` in class `DataModel`
  Returns:
    a hash code value for this object.

### setModel

    public void setModel(javax.swing.table.TableModel newModel)

  Sets Swing TableModel containing chart data.

  Parameters:
    `newModel` - containing chart data
  See Also:
    `getModel()`

### getModel

    public javax.swing.table.TableModel getModel()

  Returns the Swing TableModel containing chart data.

  Returns:
    TableModel of chart data
  See Also:
    `setModel(javax.swing.table.TableModel)`

### setSelectionModel

    public void setSelectionModel(javax.swing.ListSelectionModel newModel)

  Sets the ListSelectionModel which indicates which data values are selected.

  Parameters:
    `newModel` - the ListSelectionModel containing the indicies of the selected data values.
  Throws:
    `java.lang.IllegalArgumentException` - if `newModel` is `null`.
  See Also:
    `getSelectionModel()`

### getSelectionModel

    public javax.swing.ListSelectionModel getSelectionModel()

  Returns the ListSelectionModel that indicates which data values are selected.

  Returns:
    the ListSelectionModel containing the indicies of the selected data values.
  See Also:
    `setSelectionModel(javax.swing.ListSelectionModel)`

### isTime

    public boolean isTime()

  Deprecated. use

  Determine if the informat specified on the chart variables is a TIME type format. Both DATETIME and TIME informats will return true. DATE informats will return false.

  See Also:
    `GanttChart.isDateAxisSASTime()`, `GanttChart.isDateAxisSASDate()`, `GanttChart.isDateAxisSASDateTime()`

### setCalendarVariable

    public void setCalendarVariable(Variable newVariable)

  Specifies a variable containing the calendar variable value in which to draw breaks in schedule. This is matched with the GanttChartBreaktimeTableDataModel.getCalendarVariable() values and used to determine which breaktime calendar is applied to each task.

  Parameters:
    `newVariable` - contains the calendar for a break time.
  See Also:
    `getCalendarVariable()`

### getCalendarVariable

    public Variable getCalendarVariable()

  Returns the data column that was most recently set in the calendar role by the setCalendarVariable() method.

  Returns:
    variable for calendar of a break in the schedule of a task
  See Also:
    `setCalendarVariable(com.sas.graphics.components.Variable)`

### setTaskVariable

    public void setTaskVariable(Variable newVariable)

  Specifies Task Variable for chart bars. This variable is required to be of type String.

  Parameters:
    `newVariable` - contains the task variable for each activity.
  See Also:
    `getTaskVariable()`

### getTaskVariable

    public Variable getTaskVariable()

  Returns the data column that was most recently set in the Task role by the setTaskVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for task
  See Also:
    `setTaskVariable(com.sas.graphics.components.Variable)`

### setStyleByVariable

    public void setStyleByVariable(Variable newVariable)

  Specifies Style By Variable for coloring chart bars. When specified, the ColorVariable if set will be ignored. When this method is used, the `LegendModel.setCatagories(String[])` method must be used to associate the legend entries with the Gantt bars. To establish the association, each string value passed to `setCategories()` must match a value from the StyleBy variable including and white space.

  The following code fragment sets the String variable ActionItems as the StyleBy variable and defines three values for the legend entries. For the legend to display correctly, variable ActionItems must contain the values `Write Specifications`, `Prototype App`, and `Marketing Campaign`.

       // Set the StyleBy variable on the GanttChartTableDataModel
       dataModel.setStyleByVariable(new Variable("ActionItems"));

       // Define values for the legend entries
       String legendVals[] = new String[3];
         legendVals[0] = "Write Specifications";
         legendVals[1] = "Prototype App";
         legendVals[2] = "Marketing Campaign";

       // Set the entry values on the legend
       ganttChartModel.getLegendModel().setCategories(legendVals);

  Parameters:
    `newVariable` - contains the style by variable.
  See Also:
    `getStyleByVariable()`

### getStyleByVariable

    public Variable getStyleByVariable()

  Returns the data column that was most recently set in the StyleBy role by the setStyleByVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for the Style By variable
  See Also:
    `setStyleByVariable(com.sas.graphics.components.Variable)`

### setDrawBarVariable

    public void setDrawBarVariable(Variable newVariable)

  Specifies a numeric Variable for determining whether chart bars are drawn. If the variable's value is 0, the bar is not drawn. For any other value, the bar is drawn.

  Parameters:
    `newVariable` - contains a variable for bar drawing.
  See Also:
    `getDrawBarVariable()`

### getDrawBarVariable

    public Variable getDrawBarVariable()

  Returns the data column that was most recently set in the DrawBar role by the setDrawBarVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for the Draw Bar variable
  See Also:
    `setDrawBarVariable(com.sas.graphics.components.Variable)`

### getSuccessorVariable

    public Variable getSuccessorVariable()

  Returns the data column that was most recently set in the Successor role by the setSuccessorVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for successor
  See Also:
    `setSuccessorVariable(com.sas.graphics.components.Variable)`

### setSuccessorVariable

    public void setSuccessorVariable(Variable newVariable)

  Specifies a successor Variable for an activity. The specified variable's values identify the tasks that are successors to the activities identified by the Task variable. Successor tasks are used to display connecting lines that show the relationships among tasks. `GraphModel.setConnectingLinesEnabled()` must be set to `true` in order for the chart to display the connecting lines.

  Parameters:
    `newVariable` - contains the successor variables for each activity.
  See Also:
    `getSuccessorVariable()`

### setEarlyStartVariable

    public void setEarlyStartVariable(Variable newVariable)

  Specifies a variable containing the earliest possible point in time on which the uncompleted portions of an activity can start, based on the network logic and any schedule constraints.

  Note: All chart's Start and Finish Variables must be in the same date format and have a valid date format specifed on the Variable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  Parameters:
    `newVariable` - contains earliest start date
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getEarlyStartVariable()`

### getEarlyStartVariable

    public Variable getEarlyStartVariable()

  Returns the data column that was most recently set in the EarlyStart role by the setEarlyStartVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for Early Start
  See Also:
    `setEarlyStartVariable(com.sas.graphics.components.Variable)`

### setEarlyFinishVariable

    public void setEarlyFinishVariable(Variable newVariable)

  Specifies a variable containing the earliest possible point in time on which the uncompleted portions of an activity can finish, based on the network logic and any schedule constraints.

  Note: All chart's Start and Finish Variables must be in the same date format and have a valid date format specifed on the Variable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  Parameters:
    `newVariable` - contains earliest finish date
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getEarlyFinishVariable()`

### getEarlyFinishVariable

    public Variable getEarlyFinishVariable()

  Returns the data column that was most recently set in the EarlyFinish role by the setEarlyFinishVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for Early Finish
  See Also:
    `setEarlyFinishVariable(com.sas.graphics.components.Variable)`

### setLateStartVariable

    public void setLateStartVariable(Variable newVariable)

  Specifies variable contining the latest possible point in time that an activity can begin without delaying a specified milestone (ususally the project finish date).

  Note: All chart's Start and Finish Variables must be in the same date format and have a valid date format specifed on the Variable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  Parameters:
    `newVariable` - containing latest possible date to begin
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getLateStartVariable()`

### getLateStartVariable

    public Variable getLateStartVariable()

  Returns the data column that was most recently set in the LateStart role by the setLateStartVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for Late Start
  See Also:
    `setLateStartVariable(com.sas.graphics.components.Variable)`

### setLateFinishVariable

    public void setLateFinishVariable(Variable newVariable)

  Specifies the latest possible point in time that an activity can be completed without delaying a specific milestone (usually the project finish date).

  Note: All chart's Start and Finish Variables must be in the same date format and have a valid date format specifed on the Variable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  Parameters:
    `newVariable` - containing latest finish date
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getLateFinishVariable()`

### getLateFinishVariable

    public Variable getLateFinishVariable()

  Returns the data column that was most recently set in the LateFinish role by the setLateFinishVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for Late Finish
  See Also:
    `setLateFinishVariable(com.sas.graphics.components.Variable)`

### setResourceStartVariable

    public void setResourceStartVariable(Variable newVariable)

  Specifies variable containing resource constraint start date.

  Note: All chart's Start and Finish Variables must be in the same date format and have a valid date format specifed on the Variable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  Parameters:
    `newVariable` - containing resource constraint start dates.
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getResourceStartVariable()`

### getResourceStartVariable

    public Variable getResourceStartVariable()

  Returns the data column that was most recently set in the ResourceStart role by the setResourceStartVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for Resource Start
  See Also:
    `setResourceStartVariable(com.sas.graphics.components.Variable)`

### setResourceFinishVariable

    public void setResourceFinishVariable(Variable newVariable)

  Specifies the variable containing resource constraint finish dates.

  Note: All chart's Start and Finish Variables must be in the same date format and have a valid date format specifed on the Variable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  Parameters:
    `newVariable` - resource finish dates
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getResourceFinishVariable()`

### getResourceFinishVariable

    public Variable getResourceFinishVariable()

  Returns the data column that was most recently set in the ResourceFinish role by the setResourceFinishVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for Resource Finish
  See Also:
    `setResourceFinishVariable(com.sas.graphics.components.Variable)`

### setActualStartVariable

    public void setActualStartVariable(Variable newVariable)

  Specifies a variable containing the calendar date work actually began on an activity.

  Note: All chart's Start and Finish Variables must be in the same date format and have a valid date format specifed on the Variable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  Parameters:
    `newVariable` - date work began
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getActualStartVariable()`

### getActualStartVariable

    public Variable getActualStartVariable()

  Returns the data column that was most recently set in the ActualStart role by the setActualStartVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for Actual Start
  See Also:
    `setActualStartVariable(com.sas.graphics.components.Variable)`

### setCustomSchedule1StartVariable

    public void setCustomSchedule1StartVariable(Variable newVariable)

  Specifies the variable containing Custom Schedule 1 constraint finish dates.

  Note: All chart's Start and Finish Variables must be in the same date format and have a valid date format specifed on the Variable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  Parameters:
    `newVariable` - Custom Schedule 1 finish dates
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getCustomSchedule1StartVariable()`

### getCustomSchedule1StartVariable

    public Variable getCustomSchedule1StartVariable()

  Returns the data column that was most recently set in the CustomSchedule1Start role. Returns a null if the variable role has not been set.

  Returns:
    variable for Custom Schedule 1 Finish
  See Also:
    `setCustomSchedule1StartVariable(com.sas.graphics.components.Variable)`

### setCustomSchedule1FinishVariable

    public void setCustomSchedule1FinishVariable(Variable newVariable)

  Specifies the variable containing Custom Schedule 1 constraint finish dates.

  Note: All chart's Start and Finish Variables must be in the same date format and have a valid date format specifed on the Variable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  Parameters:
    `newVariable` - Custom Schedule 1 finish dates
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getCustomSchedule1FinshVariable()`

### getCustomSchedule1FinshVariable

    public Variable getCustomSchedule1FinshVariable()

  Returns the data column that was most recently set in the Custom Schedule 1 Finish role. Returns a null if the variable role has not been set.

  Returns:
    variable for Custom Schedule 1 Finish role.
  See Also:
    `setCustomSchedule1FinishVariable(com.sas.graphics.components.Variable)`

### setCustomSchedule2StartVariable

    public void setCustomSchedule2StartVariable(Variable newVariable)

  Specifies the variable containing Custom Schedule 2 constraint finish dates.

  Note: All chart's Start and Finish Variables must be in the same date format and have a valid date format specifed on the Variable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  Parameters:
    `newVariable` - Custom Schedule 2 start dates
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getCustomSchedule2StartVariable()`

### getCustomSchedule2StartVariable

    public Variable getCustomSchedule2StartVariable()

  Returns the data column that was most recently set in the Custom Schedule 2 Start role. Returns a null if the variable role has not been set.

  Returns:
    variable for Custom Schedule 2 Start role.
  See Also:
    `setCustomSchedule2StartVariable(com.sas.graphics.components.Variable)`

### setCustomSchedule2FinishVariable

    public void setCustomSchedule2FinishVariable(Variable newVariable)

  Specifies the variable containing Custom Schedule 2 constraint finish dates.

  Note: All chart's Start and Finish Variables must be in the same date format and have a valid date format specifed on the Variable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  Parameters:
    `newVariable` - Custom Schedule 2 finish dates
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getCustomSchedule2FinshVariable()`

### getCustomSchedule2FinshVariable

    public Variable getCustomSchedule2FinshVariable()

  Returns the data column that was most recently set in the Custom Schedule 2 Finish role. Returns a null if the variable role has not been set.

  Returns:
    variable for Custom Schedule 2 Finish role.
  See Also:
    `setCustomSchedule2FinishVariable(com.sas.graphics.components.Variable)`

### setActualFinishVariable

    public void setActualFinishVariable(Variable newVariable)

  Specifies a variable containing the calendar date work actually ended on an activity.

  Note: All chart's Start and Finish Variables must be in the same date format and have a valid date format specifed on the Variable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  Parameters:
    `newVariable` - contains actual end date
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getActualFinishVariable()`

### getActualFinishVariable

    public Variable getActualFinishVariable()

  Returns the data column that was most recently set in the ActualFinish role by the setActualFinishVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for Actual Finish
  See Also:
    `setActualFinishVariable(com.sas.graphics.components.Variable)`

### setBaselineStartVariable

    public void setBaselineStartVariable(Variable newVariable)

  Specifies variable containing the calendar date when work was scheduled to begin on an activity.

  Note: All chart's Start and Finish Variables must be in the same date format and have a valid date format specifed on the Variable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  Parameters:
    `newVariable` - when work was scheduled to begin
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getBaselineStartVariable()`

### getBaselineStartVariable

    public Variable getBaselineStartVariable()

  Returns the data column that was most recently set in the BaselineStart role by the setBaselineStartVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for Baseline Start
  See Also:
    `setBaselineStartVariable(com.sas.graphics.components.Variable)`

### setBaselineFinishVariable

    public void setBaselineFinishVariable(Variable newVariable)

  Specifies a variable containing calendar date of when work is scheduled to end on an activity.

  Note: All chart's Start and Finish Variables must be in the same date format and have a valid date format specifed on the Variable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  Parameters:
    `newVariable` - containing end dates for an activity.
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getBaselineFinishVariable()`

### getBaselineFinishVariable

    public Variable getBaselineFinishVariable()

  Returns the data column that was most recently set in the BaselineFinish role by the setBaselineFinishVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for Baseline Finish
  See Also:
    `setBaselineFinishVariable(com.sas.graphics.components.Variable)`

### setDurationVariable

    public void setDurationVariable(Variable newVariable)

  Duration of an activity. Duration value of zero produces a milestone marker if milestone markers are setVisible(true):
  ganttChart.getGraphModel().getMilestoneMarkerStyle().setVisible(milestoneEnabled);

  Parameters:
    `newVariable` - duration value for an activity.
  See Also:
    `getDurationVariable()`

### getDurationVariable

    public Variable getDurationVariable()

  Returns the data column that was most recently set in the Duration role by the setDurationVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable containing duration values
  See Also:
    `setDurationVariable(com.sas.graphics.components.Variable)`

### setTargetVariable

    public void setTargetVariable(Variable newVariable)

  Specifies a variable containing the target dates

  Note: All chart's date Variables must be in the same date format and have a valid date format specifed on the Variable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  Parameters:
    `newVariable` - contains target date
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getTargetVariable()`

### getTargetVariable

    public Variable getTargetVariable()

  Returns the data column that was most recently set in the Target role by the setTargetVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for Target
  See Also:
    `setTargetVariable(com.sas.graphics.components.Variable)`

### setDescriptionVariable

    public void setDescriptionVariable(Variable newVariable)

  Specifies a variable containing text to be displayed in the TreeTable instead of the actual Task variable values. This only applies when there is a valid displayable TreeTable. This variable is required to be of type String.

  Parameters:
    `newVariable` - contains descriptive information
  See Also:
    `getDescriptionVariable()`

### getDescriptionVariable

    public Variable getDescriptionVariable()

  Returns the data column that was most recently set in the Description role by the setDescriptionVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for Description
  See Also:
    `setDescriptionVariable(com.sas.graphics.components.Variable)`

### setColorVariable

    public void setColorVariable(Variable newVariable)

  Specifies a variable containing the color values for the bars. Values of this variable are of type String and are one of the possible SASColors as well as "TRANSPARENT". When the StyleByVariable is specified, the ColorVariable will be ignored.

  Parameters:
    `newVariable` - contains color values
  See Also:
    `getColorVariable()`

### getColorVariable

    public Variable getColorVariable()

  Returns the data column that was most recently set in the Color role by the setColorVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for color
  See Also:
    `setColorVariable(com.sas.graphics.components.Variable)`

### setParentVariable

    public void setParentVariable(Variable newVariable)

  Specifies a variable containing the parent value for each task and is used in displaying hierarchial tasks on the task axis.

  Parameters:
    `newVariable` - contains parent values for each task
  See Also:
    `getParentVariable()`

### getParentVariable

    public Variable getParentVariable()

  Returns the data column that was most recently set in the Parent role by the setParentVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for parent values
  See Also:
    `setParentVariable(com.sas.graphics.components.Variable)`

### setAnnotationTaskVariable

    public void setAnnotationTaskVariable(Variable newVariable)

  Specifies a variable whose values identify the task bars to use for displaying annotations on the chart. By default, the annotations are displayed on the TaskVariable value for the current record.

  The annotation can be a symbol or text, depending on whether setAnnotationSymbolVariable() or setAnnotationLabelVariable() is also called. The annotation's position on the date axis is determined by setAnnotationLocationVariable() or setAnnotationPositionVariable().

  Parameters:
    `newVariable` - contains a variable whose values identify the task bars to use for displaying annotations
  See Also:
    `getAnnotationTaskVariable()`, `setAnnotationSymbolVariable(com.sas.graphics.components.Variable)`, `setAnnotationLabelVariable(com.sas.graphics.components.Variable)`, `setAnnotationLocationVariable(com.sas.graphics.components.Variable)`, `setAnnotationPositionVariable(com.sas.graphics.components.Variable)`

### getAnnotationTaskVariable

    public Variable getAnnotationTaskVariable()

  Returns the data column that was most recently set in the AnnotationTask role by the setAnnotationTaskVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for task to draw
  See Also:
    `setAnnotationTaskVariable(com.sas.graphics.components.Variable)`

### setAnnotationLocationVariable

    public void setAnnotationLocationVariable(Variable newVariable)

  Specifies a String variable whose values identify a date-axis location to use for displaying annotations. The location is based on a task's start or finish date, and the String variable's values must be one of the following enumeration values:
  ES
    Set the annotation to the task's Early Start date
  EF
    Set the annotation to the task's Early Finish date
  LS
    Set the annotation to the task's Late Start date
  LF
    Set the annotation to the task's Late Finish date

  The annotation can be a symbol or text, depending on whether setAnnotationSymbolVariable() or setAnnotationLabelVariable() is also called. You can call setAnnotationPositionVariable() to set an absolute position for the annotation rather than this relative location.

  Parameters:
    `newVariable` - contains where to locate the marker or text
  See Also:
    `getAnnotationLocationVariable()`, `setAnnotationSymbolVariable(com.sas.graphics.components.Variable)`, `setAnnotationLabelVariable(com.sas.graphics.components.Variable)`, `setAnnotationPositionVariable(com.sas.graphics.components.Variable)`

### getAnnotationLocationVariable

    public Variable getAnnotationLocationVariable()

  Returns the data column that was most recently set in the AnnotationLocation role by the setAnnotationLocationVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for marker or text location values
  See Also:
    `setAnnotationLocationVariable(com.sas.graphics.components.Variable)`

### setAnnotationPositionVariable

    public void setAnnotationPositionVariable(Variable newVariable)

  Specifies a variable whose values identify a specific date-axis location to use for displaying annotations. The specified variable's values must be valid date values.

  Note: This variable must be the same format as the chart's Start and Finish Variables and have a valid date format specifed on the newVariable.
  Examples of valid date formats are:

  - DATE5. - "ddMMM"
  - DATE7. - "ddMMMyy"
  - DATE9. - "ddMMMyyyy"
  - DATETIME13. - "ddMMMyy:HH:mm"
  - DATETIME16. - "ddMMMyy:HH:mm:ss"
  - DATETIME18. - "ddMMMyyyy:HH:mm:ss"
  - DATETIME20. - "ddMMMyy:HH:mm:ss.SSS"
  - DATETIME22. - "ddMMMyyyy:HH:mm:ss.SSS"
  - TIME5. - "HH:mm"
  - TIME8. - "HH:mm:ss""
  - TIME12. - "HH:mm:ss.SSS"

  The annotation can be a symbol or text, depending on whether setAnnotationSymbolVariable() or setAnnotationLabelVariable() is also called. You can call setAnnotationLocationVariable() to set annotation positions that are relative to to the task's start or finish dates.

  Parameters:
    `newVariable` - contains the date position to place the marker or text
  Throws:
    `java.lang.IllegalArgumentException` - if format is null, needs a valid date format specifed.
  See Also:
    `getAnnotationPositionVariable()`, `setAnnotationLocationVariable(com.sas.graphics.components.Variable)`, `setAnnotationSymbolVariable(com.sas.graphics.components.Variable)`, `setAnnotationLabelVariable(com.sas.graphics.components.Variable)`

### getAnnotationPositionVariable

    public Variable getAnnotationPositionVariable()

  Returns the data column that was most recently set in the AnnotationPosition role by the setAnnotationPositionVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for marker or text position
  See Also:
    `setAnnotationPositionVariable(com.sas.graphics.components.Variable)`

### setAnnotationSymbolVariable

    public void setAnnotationSymbolVariable(Variable newVariable)

  Specifies a Variable whose values specify the symbol to use for displaying annotations. The Variable's values must be int values defined by one of the SYMBOL_ fields in the MarkerStyle class, such as `MarkerStyle.SYMBOL_DIAMOND_FILLED`.

  Call setAnnotationLocationVariable() to position the symbol at a date-axis location that is based on a task start or finish date. Call setAnnotationPositionVariable() to position the symbol at a specific location on the date axis.

  Parameters:
    `newVariable` - Variable containing valid values for symbols.
  See Also:
    `getAnnotationSymbolVariable()`, `setAnnotationLocationVariable(com.sas.graphics.components.Variable)`, `setAnnotationLabelVariable(com.sas.graphics.components.Variable)`, `setAnnotationPositionVariable(com.sas.graphics.components.Variable)`

### getAnnotationSymbolVariable

    public Variable getAnnotationSymbolVariable()

  Returns the data column that was most recently set in the AnnotationSymbol role by the setAnnotationSymbolVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for the marker symbols
  See Also:
    `setAnnotationSymbolVariable(com.sas.graphics.components.Variable)`

### setAnnotationLabelVariable

    public void setAnnotationLabelVariable(Variable newVariable)

  Specifies a String Variable whose values specify the text to use for displaying annotations.

  Call setAnnotationLocationVariable() to position the text at a date-axis location that is based on a task start or finish date. Call setAnnotationPositionVariable() to position the text at a specific location on the date axis.

  Parameters:
    `newVariable` - contains text strings to draw
  See Also:
    `getAnnotationLabelVariable()`, `setAnnotationSymbolVariable(com.sas.graphics.components.Variable)`, `setAnnotationLocationVariable(com.sas.graphics.components.Variable)`, `setAnnotationPositionVariable(com.sas.graphics.components.Variable)`

### getAnnotationLabelVariable

    public Variable getAnnotationLabelVariable()

  Returns the data column that was most recently set in the AnnotationLabel role by the setAnnotationLabelVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for text to draw
  See Also:
    `setAnnotationLabelVariable(com.sas.graphics.components.Variable)`

### setAnnotationSymbolColorVariable

    public void setAnnotationSymbolColorVariable(Variable newVariable)

  Specifies a variable containing color values for the marker symbols used for displaying annotations.

  Parameters:
    `newVariable` - contains marker symbol color
  See Also:
    `getAnnotationSymbolColorVariable()`, `setAnnotationSymbolVariable(com.sas.graphics.components.Variable)`

### getAnnotationSymbolColorVariable

    public Variable getAnnotationSymbolColorVariable()

  Returns the data column that was most recently set in the AnnotationSymbolColor role by the setAnnotationSymbolColorVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for symbol color
  See Also:
    `setAnnotationSymbolColorVariable(com.sas.graphics.components.Variable)`

### setAnnotationLabelColorVariable

    public void setAnnotationLabelColorVariable(Variable newVariable)

  Specifies a variable containing color values for the text used for displaying annotations.

  Parameters:
    `newVariable` - contains text marker color
  See Also:
    `getAnnotationLabelColorVariable()`, `setAnnotationLabelVariable(com.sas.graphics.components.Variable)`

### getAnnotationLabelColorVariable

    public Variable getAnnotationLabelColorVariable()

  Returns the data column that was most recently set in the AnnotationLabelColor role by the setAnnotationLabelColorVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for Text marker color
  See Also:
    `setAnnotationLabelColorVariable(com.sas.graphics.components.Variable)`

### setAnnotationLabelJustificationVariable

    public void setAnnotationLabelJustificationVariable(Variable newVariable)

  Specifies a String variable whose values identify justification to use for displaying annotations. The justification is based the value found in the setAnnotationPositionVariable or setAnnotationLocationVariable variable, and the String variable's values must be one of the following enumeration values:
  LEFT
    Set the annotation to be left justified
  RIGHT
    Set the annotation to be right justified
  CENTER
    Set the annotation to be center justified
  However, if a Numeric variable is applied, the variable's values must be one of the following SwingContants:
  javax.swing.SwingConstants.LEFT
    Set the annotation to be left justified
  javax.swing.SwingConstants.RIGHT
    Set the annotation to be right justified
  javax.swing.SwingConstants.CENTER
    Set the annotation to be center justified

  Parameters:
    `newVariable` - contains where to justify the text
  See Also:
    `getAnnotationLocationVariable()`, `setAnnotationLabelVariable(com.sas.graphics.components.Variable)`, `setAnnotationPositionVariable(com.sas.graphics.components.Variable)`

### getAnnotationLabelJustificationVariable

    public Variable getAnnotationLabelJustificationVariable()

  Returns the data column that was most recently set in the AnnotationLabelJustification role by the setannotationLabelJustificationVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for text justification values
  See Also:
    `setAnnotationLabelJustificationVariable(com.sas.graphics.components.Variable)`

### setReplaceWithChildrenVariable

    public void setReplaceWithChildrenVariable(Variable newVariable)

  Specifies a variable whose values let the chart know if it is to draw the children of this task on this row instead of drawing the task bar. For now, this only applies for the first level parent bars.

  Parameters:
    `newVariable` - contains 1 for TRUE and 0 for FALSE
  See Also:
    `getReplaceWithChildrenVariable()`

### getReplaceWithChildrenVariable

    public Variable getReplaceWithChildrenVariable()

  Returns the data column that was most recently set in the ReplaceWithChildren role by the setReplaceWithChildrenVariable() method. Returns a null if the variable role has not been set.

  Returns:
    variable for Replacing Children for Parent bar.
  See Also:
    `setReplaceWithChildrenVariable(com.sas.graphics.components.Variable)`

### setDataTipVariable

    public void setDataTipVariable(Variable[] newVariables)

  Specifies an array of Variables to be displayed in the data tip. By default, the variables specified on setDataTipVariable() are appended to the end of the default data tip display. To replace the default display with the list of variables in the Variable[] array, use the GraphModel to get the DataTipModel , and the call the DataTipModel's setContent() method with the value GraphConstants.DATA_TIP_REPLACE.

  The following code fragment specifies two variables for the data tip display and uses them to replace the default data tip display:

       // Create an array of variables to set in the data tip display
          Variable dataTipVars[] = new Variable[2];
            dataTipVars[0] = new Variable("Task");
            dataTipVars[1] = new Variable("Duration");
          ganttChart.getGraphModel().getDataTipModel().setContent(GraphConstants.DATA_TIP_REPLACE);

  Parameters:
    `newVariables` - array of Variables to display in data tip
  Throws:
    `java.lang.IllegalArgumentException` - if a non-null array of zero length is passed in.
  See Also:
    `getDataTipVariable()`, `setAuxiliaryVariable(com.sas.graphics.components.Variable[])`

### getDataTipVariable

    public Variable[] getDataTipVariable()

  Returns the array of data columns that was most recently set by the setDataTipVariable() method. Returns null if the data tip variables were not set.

  Returns:
    variables for data tip values
  See Also:
    `setDataTipVariable(com.sas.graphics.components.Variable[])`

### setAuxiliaryVariable

    public void setAuxiliaryVariable(Variable[] newVariables)

  Specifies an array of Variables that are included among the variables that are passed in the events on the Gantt bars. Auxiliary variables are not represented in the chart. By default, they are not displayed in the datatip, although they can be included in the array of variables set by setDataTipVariable().

  Parameters:
    `newVariables` - contains Variables for GraphActionEvent return.
  Throws:
    `java.lang.IllegalArgumentException` - if a non-null array of zero length is passed in.
  See Also:
    `getAuxiliaryVariable()`, `setDataTipVariable(com.sas.graphics.components.Variable[])`

### getAuxiliaryVariable

    public Variable[] getAuxiliaryVariable()

  Returns the array of data columns that was most recently set by the setAuxiliaryVariable() method. Returns null if the auxiliary variables were not set.

  Returns:
    variables for Auxiliary values
  See Also:
    `setAuxiliaryVariable(com.sas.graphics.components.Variable[])`, `setDataTipVariable(com.sas.graphics.components.Variable[])`

All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Components |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2009 SAS Institute Inc. All Rights Reserved.